//+------------------------------------------------------------------+
//|                                                     5 Ballov.mq4 |
//|                                                          Phoenix |
//|                                             http://www.udaff.com |
//+------------------------------------------------------------------+
#property copyright "Phoenix"
#property link      "http://www.udaff.com"

extern int        OptimizeLotMethod  = 3;
extern double     MaximumRisk        = 0.04;
double            DecreaseFactor     = 3;

extern int     RsiPeriod    = 9;
extern int     RsiLevel     = 50;
extern int     StohPeriod   = 5;
extern int     StohLevel    = 30;

extern int StopDelta        = 3;
extern int LevelDelta       = 5;
extern int LevelProfitDelta = 5;
extern int MaxLoss          = 40;
extern int MinLoss          = 15;
extern double RiskFucktor   = 0.5;

extern int ParitetIn        = 15;
extern int TralBars         = 1;
extern int CloseHours       = 12;
extern int SessionStart     = 8;
extern int SessionEnd       = 17;


#include <TradingLib.mqh>

#define MAGICMA  19
string s_mtsName = "5 Ballov";


// Main process
void CheckForOpen()
{
   if( Volume[0]>1 ) return;
   if( CheckOpened( MAGICMA ) ) return;
   if( !PX_TestWorkTime(0,8,18,25 ) ) return;
   
   // Var
   int res = 0;
   
   // Indexes
   double _apcUpH = iCustom( NULL,PERIOD_H1,"BelomorKanal",120,120,12,5,0,1 );
   double _apcLoH = iCustom( NULL,PERIOD_H1,"BelomorKanal",120,120,12,5,1,1 );
   double _apcUpD = iCustom( NULL,PERIOD_D1,"BelomorKanal",22,65,4,5,0,1 );
   double _apcLoD = iCustom( NULL,PERIOD_D1,"BelomorKanal",22,65,4,5,1,1 );
   double _apcUpW = iCustom( NULL,PERIOD_W1,"BelomorKanal",26,24,4,5,0,1 );
   double _apcLoW = iCustom( NULL,PERIOD_W1,"BelomorKanal",26,24,4,5,1,1 );
   
   double _apcUp = MathMin(MathMin(_apcUpH,_apcUpD),_apcUpW);
   double _apcLo = MathMax(MathMax(_apcLoH,_apcLoD),_apcLoW);
   //double _apcUp = _apcUpH;
   //double _apcLo = _apcLoH;
   
   double _rsi1 = iRSI( NULL,0,RsiPeriod,PRICE_MEDIAN,1 );
   double _rsi2 = iRSI( NULL,0,RsiPeriod,PRICE_MEDIAN,2 );
   double _stoh1 = iStochastic( NULL,0,StohPeriod,3,2,MODE_EMA,1,MODE_MAIN,1 );
   double _stoh2 = iStochastic( NULL,0,StohPeriod,3,2,MODE_EMA,1,MODE_MAIN,2 );
   
   // Test Time
   bool b_timeOK = PX_TestWorkTime(0,SessionStart,SessionEnd);
   
   // Long
   if( Low[3]>_apcLo && (Low[1]<=_apcLo+LevelDelta*Point || Low[2]<=_apcLo+LevelDelta*Point) && Close[1]>_apcLo // Otboi
       && _rsi1<=RsiLevel && _rsi1>_rsi2 // Rsi
       && _stoh1<=StohLevel && _stoh1>_stoh2 // Shohastik
       && (Ask-MathMin(Low[1],Low[2])+StopDelta*Point) <= MaxLoss*Point // MaxLoss
       && (Ask-MathMin(Low[1],Low[2])+StopDelta*Point) >= MinLoss*Point // MinLoss
       //&& (Ask-MathMin(Low[1],Low[2])+StopDelta*Point) <= (_apcUp-LevelProfitDelta*Point-Ask)*RiskFucktor // Risk
       && b_timeOK // Time OK
     )
   {
      res = OrderSend(Symbol(),OP_BUY,LotsOptimized(MAGICMA, 0, 0.01, 0 ),Ask,3,MathMin(Low[1],Low[2])-StopDelta*Point,_apcUp-LevelProfitDelta*Point,BuyComent(s_mtsName),MagicMA(MAGICMA),0,Blue);
      ReportAction( "Buy " + PX_NormPrice(Ask) );
      ReportOrder(res);
   }
   
   // Short
   if( High[3]<_apcUp && (High[1]>=_apcUp-LevelDelta*Point || High[2]>=_apcUp-LevelDelta*Point) && Close[1]<_apcUp // Otboi
       && _rsi1>=100-RsiLevel && _rsi1<_rsi2 // Rsi
       && _stoh1>=100-StohLevel && _stoh1<_stoh2 // Shohastik
       && (MathMin(High[1],High[2])+(StopDelta+PX_GetSpread(Symbol()))*Point-Bid) <= MaxLoss*Point // MaxLoss
       && (MathMin(High[1],High[2])+(StopDelta+PX_GetSpread(Symbol()))*Point-Bid) >= MinLoss*Point // MinLoss
       //&& (MathMin(High[1],High[2])+(StopDelta+PX_GetSpread(Symbol()))*Point-Bid) <= (Bid-(_apcLo+LevelProfitDelta*Point))*RiskFucktor // Risk
       && b_timeOK // Time OK
     )
   {
      res = OrderSend(Symbol(),OP_SELL,LotsOptimized(MAGICMA, 0, 0.01, 0 ),Bid,3,MathMax(High[1],High[2])+(StopDelta+PX_GetSpread(Symbol()))*Point,_apcLo+LevelProfitDelta*Point,SellComent(s_mtsName),MagicMA(MAGICMA),0,Blue);
      ReportAction( "Sell " + PX_NormPrice(Bid) );
      ReportOrder(res);
   }
   
   
   // Report
   ReportClose();
}



//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
   int i;
   ReportsInit( s_mtsName );
   
   // Process currecnt tick   
   CheckForOpen();
   //TrailingMove( s_mtsName, MAGICMA,5,22,0,ParitetIn,StopFactor );
   TrailingMove( s_mtsName, MAGICMA,2,TralBars,StopDelta,ParitetIn,0 );
   //ProfitMove( s_mtsName, MAGICMA,2,PowerPeriod,0,1 );
   TimeClose( s_mtsName, MAGICMA, PERIOD_H1, CloseHours );

//----
   ReportsSend();
   return(0);
}
//+------------------------------------------------------------------+