//+------------------------------------------------------------------+
//|                                                    WinUser32.mqh |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#define   copyright "Copyright  2004, MetaQuotes Software Corp."
#define   link      "http://www.metaquotes.net/"
#include <stdlib.mqh>


string _reportmsg;
string _mts_name;

string RPT_StrClr( string _str )
{
   string _res = StringTrimRight(StringTrimLeft( _str ) );
   int _len = StringLen( _res );
   while( StringGetChar(_res,_len) == '\n' )
      _res = StringSubstr(_res,0,_len-1);
   
   return( _res );
}

void RPT_Send( string msg )
{
   //send_message( uin,RPT_StrClr(msg) );
}

//
void ReportsSend()
{
   string _period;
   switch( Period() )
   {
      case PERIOD_M1: _period = "M1"; break;
      case PERIOD_M5: _period = "M5"; break;
      case PERIOD_M15: _period = "M15"; break;
      case PERIOD_M30: _period = "M30"; break;
      case PERIOD_H1: _period = "H1"; break;
      case PERIOD_H4: _period = "H4"; break;
      case PERIOD_D1: _period = "D1"; break;
      case PERIOD_W1: _period = "W1"; break;
      case PERIOD_MN1: _period = "MN1"; break;
      default: _period = Period(); break;
   }
   
   if( !IsTesting() )
      RPT_Send( _mts_name + " " + Symbol() + " " + _period + ": " + _reportmsg );
   //Print(_mts_name + ": " + _reportmsg);
}

void ReportOrder( int  _res )
{
   if( _res<0 && !IsTesting())
      _reportmsg = _reportmsg + ( "\nError setting order: "+ErrorDescription(GetLastError()));
}

void ReportsInit( string _mtsname )
{
   _mts_name = _mtsname;
   _reportmsg = "";
}

void ReportAction( string _rep )
{
   _reportmsg = _reportmsg + "\n" + _rep;
}

void ReportClose()
{
   if( _reportmsg == "" )
      _reportmsg = "Hour " + TimeHour(LocalTime()) + " processed, no position";
}