//+------------------------------------------------------------------+
//|                                                            PxLib |
//|                                                          Phoenix |
//|                                             http://www.udaff.com |
//+------------------------------------------------------------------+
#property copyright "Phoenix"
#property link      "http://www.udaff.com"

#include <stdlib.mqh>

int DefPeriodFast( int TimeFrame )
{
   switch( TimeFrame )
   {
      case PERIOD_M1:
      case PERIOD_M15:
      case PERIOD_M30:
      case PERIOD_H1:   return(24);
      case PERIOD_H4:   return(30);
      case PERIOD_D1:   return(22);
      case PERIOD_W1:   return(13);
      case PERIOD_MN1:  return(12);
   }
   
   return(9);
}

int DefPeriodSlow( int TimeFrame )
{
   switch( TimeFrame )
   {
      case PERIOD_M1:
      case PERIOD_M15:
      case PERIOD_M30:
      case PERIOD_H1:   return(120);
      case PERIOD_H4:   return(132);
      case PERIOD_D1:   return(130);
      case PERIOD_W1:   return(52);
      case PERIOD_MN1:  return(58);
   }
   
   return(9);
}

int TestPeriod( int TimeFrame )
{
   switch( TimeFrame )
   {
      case PERIOD_M1:
      case PERIOD_M15:
      case PERIOD_M30:
      case PERIOD_H1:   return(PERIOD_H4);
      case PERIOD_H4:   return(PERIOD_D1);
      case PERIOD_D1:   return(PERIOD_W1);
      case PERIOD_W1:   return(PERIOD_MN1);
      case PERIOD_MN1:  return(0);
   }
   
   return(9);
}

double PX_GetPoint( string parSymbol )
{
   double rvPoint = 0;
   if( parSymbol ==  "EURUSD" || parSymbol ==  "USDCHF" || parSymbol ==  "GBPUSD" || parSymbol ==  "EURGBP" || parSymbol ==  "AUDUSD"|| parSymbol ==  "USDCAD")
   {
      rvPoint = 0.0001;
   }
   else if( parSymbol ==  "USDJPY" || parSymbol ==  "EURJPY" || parSymbol ==  "GBPJPY" )
   {
      rvPoint = 0.01;
   }
   else
   {
      Alert( "Unsupported Symbol: " + parSymbol );
   }
   
   //return( MarketInfo(parSymbol,MODE_POINT) );
}

double PX_GetSpread( string parSymbol )
{
   
   double rvSpread = 0;
   if( parSymbol ==  "EURUSD" || parSymbol ==  "USDCHF" || parSymbol ==  "GBPUSD" || parSymbol ==  "AUDUSD" || parSymbol ==  "USDCAD")
   {
      rvSpread = 5;
   }
   else if( parSymbol ==  "USDJPY" || parSymbol ==  "EURJPY" )
   {
      rvSpread = 5;
   }
   else if( parSymbol ==  "EURGBP" )
   {
      rvSpread = 5;
   }
   else if(parSymbol ==  "GBPJPY" )
   {
      rvSpread = 9;
   }
   else
   {
      Alert( "Unsupported Symbol: " + parSymbol );
   }
   
   //return( MarketInfo(parSymbol,MODE_SPREAD) );
}

bool PXX_DeleteOneObject()
{
   int i_objTotal=ObjectsTotal();
   string s_objName;
   
   for( int i=0;i<i_objTotal;i++ )
   {
      s_objName=ObjectName(i);
      ObjectDelete( s_objName );
      return( TRUE );
   }
}

void PX_DeleteAllObjects( )
{
   while( PXX_DeleteOneObject() )
   {
   }
}

bool PX_TestHandle(int Pos,double ScaleVal)
{
   if( MathAbs( Open[Pos]-Close[Pos] )*ScaleVal > (High[Pos]-Low[Pos]) )
      return( TRUE );
      
   return( FALSE );
}

bool PX_TestFrahtalUP( int pos )
{
   if( High[pos] >= High[pos+1] && High[pos] > High[pos+2] && High[pos] >= High[pos-1] && High[pos] > High[pos-2] )
      return( TRUE );
      
   return( FALSE );
}

bool PX_TestFrahtalDown( int pos )
{
   if( Low[pos] <= Low[pos-1] && Low[pos] < Low[pos-2] && Low[pos] <= Low[pos+1] && Low[pos] < Low[pos+2] )
      return( TRUE );
      
   return( FALSE );
}

int PX_FindFrahtalUP()
{
   for( int i=1;i<120;i++ )
   {
      if( PX_TestFrahtalUP( i ) )
         return( i );
   }
      
   return( 0 );
}

int PX_FindFrahtalDown()
{
   for( int i=1;i<120;i++ )
   {
      if( PX_TestFrahtalDown( i ) )
         return( i );
   }
      
   return( 0 );
}

bool PX_TestWorkTime( int pos,int time_Min,int time_Max, int time_Close=25 )
{
   int h_time = TimeHour( iTime( NULL,0,pos ) );
   if( h_time>=time_Min && h_time<time_Max && h_time<time_Close )
      return( TRUE );
      
   return( FALSE );
}

bool PX_TestEveningClose( int pos, int time_Close )
{
   int h_time = TimeHour( iTime( NULL,0,pos ) );
   if( h_time>=time_Close )
      return( TRUE );
   
   return( FALSE );
}

string PX_GlobalVarName( string _expertName, string _varName )
{
   if( IsTesting() )
      return( "Test_" + _expertName + Symbol() + Period() + "_" + _varName );
      
   return( _expertName + Symbol() + Period() + "_" + _varName );
}

double PX_NormPrice( double _d )
{
   return( NormalizeDouble(_d,MarketInfo(Symbol(),MODE_DIGITS) ) );
}