//+------------------------------------------------------------------+
//|                                                 BelomorKanal.mq4 |
//|                                        Copyright  2006, Phoenix |
//|                                             http://www.udaff.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Phoenix"
#property link      "http://www.udaff.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Red

//---- input parameters
extern int       PC_Period      = 24;
extern int       LevelDur       = 72;
extern int       LevelMinDur    = 8;
extern int       LevelMinDest   = 5;

//---- buffers
double ExtMapBufferHi[];
double ExtMapBufferLow[];

int    MaxLevels = 100;
double VertexPriceBuffer[100];
int    VertexFirstIndexBuffer[100];
int    VertexLastIndexBuffer[100];
int    CurIndex=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBufferHi);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBufferLow);

//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
//---- TODO: add your code here
   
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
{
   if( Bars<=PC_Period*2+1 ) return(0);
   
   int    i,j, counted_bars=IndicatorCounted();
   bool _levelFound;
   double _upperLevel, _lowerLevel;
   
   // Process new bars
   for( j=0;j<MaxLevels && !_levelFound;j++ )
   {
      VertexLastIndexBuffer[j] = VertexLastIndexBuffer[j]+Bars-counted_bars;
      VertexFirstIndexBuffer[j] = VertexFirstIndexBuffer[j]+Bars-counted_bars;
   }
   
//----
   for(i=Bars-counted_bars; i>=0; i--)
   {
      double _pcUp1   = iCustom( NULL, 0, "PChannel",PC_Period, 0, i );
      double _pcDown1 = iCustom( NULL, 0, "PChannel",PC_Period, 1, i );
      double _pcUp2   = iCustom( NULL, 0, "PChannel",PC_Period, 0, i+1 );
      double _pcDown2 = iCustom( NULL, 0, "PChannel",PC_Period, 1, i+1 );
      
      // Flat PC found UP
      if( _pcUp1==_pcUp2 )
      {
         // Find if olready in list
         _levelFound = false;
         for( j=0;j<MaxLevels && !_levelFound;j++ )
         {
            if( MathAbs(VertexPriceBuffer[j]-_pcUp1)<=LevelMinDest*Point && VertexFirstIndexBuffer[j]-i>LevelMinDur )
            {
               _levelFound = true;
               VertexLastIndexBuffer[j] = i;
            }
         }
         
         // It is new level
         if( !_levelFound )
         {
            CurIndex++;
            VertexPriceBuffer[CurIndex] = _pcUp1;
            VertexLastIndexBuffer[CurIndex] = i;
            VertexFirstIndexBuffer[CurIndex] = i;
         }
      }
      
      // Flat PC found Down
      if( _pcDown1==_pcDown2 )
      {
         // Find if olready in list
         _levelFound = false;
         for( j=0;j<MaxLevels && !_levelFound;j++ )
         {
            if( MathAbs(VertexPriceBuffer[j]-_pcDown1)<=LevelMinDest*Point && VertexFirstIndexBuffer[j]-i>LevelMinDur )
            {
               _levelFound = true;
               VertexLastIndexBuffer[j] = i;
            }
         }
         
         // It is new level
         if( !_levelFound )
         {
            CurIndex++;
            VertexPriceBuffer[CurIndex] = _pcDown1;
            VertexFirstIndexBuffer[j] = i;
            VertexLastIndexBuffer[j] = i;
         }
      }
      
      // Fund borders
      _upperLevel = 99999;
      _lowerLevel = 0;
      for( j=0; j<MaxLevels; j++ )
      {
         // Cancel old vertex
         if( VertexLastIndexBuffer[j]-i>LevelDur )
         {
            VertexPriceBuffer[j]=0;
            VertexFirstIndexBuffer[j]=99999;
            VertexLastIndexBuffer[j]=99999;
         }
         else
         {
            // Check levels
            if( VertexPriceBuffer[j]!=0 && VertexPriceBuffer[j]<_upperLevel && (Close[i]<VertexPriceBuffer[j] || Close[i+1]<VertexPriceBuffer[j]) && VertexFirstIndexBuffer[j]-i>LevelMinDur  )
               _upperLevel = VertexPriceBuffer[j];
            if( VertexPriceBuffer[j]>_lowerLevel && (Close[i]>VertexPriceBuffer[j] || Close[i+1]>VertexPriceBuffer[j]) && VertexFirstIndexBuffer[j]-i>LevelMinDur )
               _lowerLevel = VertexPriceBuffer[j];
         }
      }
      ExtMapBufferHi[i]  = _upperLevel;
      ExtMapBufferLow[i] = _lowerLevel;
      
      /*if( _upperLevel == 99999 )
         ExtMapBufferHi[i+1] = ExtMapBufferHi[i];
      if( _lowerLevel == 0 )
         ExtMapBufferLow[i+1] = ExtMapBufferLow[i];
      */
      // if level array is full
      if(CurIndex>=MaxLevels)
      {
         CurIndex = 0;
      }
   }

//----
   return(0);
}
//+------------------------------------------------------------------+